sidebarNodes={"extras":[{"id":"api-reference","title":"API Reference","group":"","headers":[{"id":"Modules","anchor":"modules"},{"id":"Mix Tasks","anchor":"mix-tasks"}]},{"id":"installation","title":"Installation","group":"","headers":[{"id":"MacOS","anchor":"macos"},{"id":"Linux","anchor":"linux"},{"id":"All platforms","anchor":"all-platforms"}]},{"id":"getting-started","title":"Getting Started","group":"","headers":[{"id":"Introduction","anchor":"introduction"},{"id":"Common terms","anchor":"common-terms"},{"id":"Creating a new Nerves app","anchor":"creating-a-new-nerves-app"},{"id":"Building and deploying firmware","anchor":"building-and-deploying-firmware"},{"id":"Connecting to your Nerves target","anchor":"connecting-to-your-nerves-target"},{"id":"Nerves examples","anchor":"nerves-examples"}]},{"id":"faq","title":"Frequently-Asked Questions","group":"","headers":[{"id":"Using a USB Serial Console","anchor":"using-a-usb-serial-console"},{"id":"Change Behavior on BEAM Failure","anchor":"change-behavior-on-beam-failure"},{"id":"Platform-Specific Hardware Support","anchor":"platform-specific-hardware-support"}]},{"id":"targets","title":"Targets","group":"","headers":[{"id":"Supported Targets and Systems","anchor":"supported-targets-and-systems"},{"id":"Supporting New Target Hardware","anchor":"supporting-new-target-hardware"}]},{"id":"systems","title":"Systems","group":"","headers":[{"id":"Using a Nerves System","anchor":"using-a-nerves-system"},{"id":"Anatomy of a Nerves System","anchor":"anatomy-of-a-nerves-system"},{"id":"Nerves Package Configuration","anchor":"nerves-package-configuration"},{"id":"Customizing Your Own Nerves System","anchor":"customizing-your-own-nerves-system"}]},{"id":"user-interfaces","title":"User Interfaces","group":"","headers":[{"id":"Phoenix web interfaces","anchor":"phoenix-web-interfaces"}]},{"id":"advanced-configuration","title":"Advanced Configuration","group":"","headers":[{"id":"Target-Specific Configuration","anchor":"target-specific-configuration"},{"id":"Root Filesystem Overlays","anchor":"root-filesystem-overlays"},{"id":"Partitions","anchor":"partitions"}]},{"id":"updating-projects","title":"Updating Projects","group":"","headers":[{"id":"Updating from v0.8 to v0.9","anchor":"updating-from-v0-8-to-v0-9"},{"id":"Updating from v0.9 to v1.0.0-rc.0","anchor":"updating-from-v0-9-to-v1-0-0-rc-0"},{"id":"Updating from v1.0.0-rc.0 to v1.0.0-rc.2","anchor":"updating-from-v1-0-0-rc-0-to-v1-0-0-rc-2"},{"id":"Updating from v1.0 to v1.3","anchor":"updating-from-v1-0-to-v1-3"},{"id":"Updating from v1.3 to v1.4","anchor":"updating-from-v1-3-to-v1-4"},{"id":"Updating from v1.4 to v1.5","anchor":"updating-from-v1-4-to-v1-5"}]},{"id":"internals","title":"Nerves Internals","group":"","headers":[{"id":"Call Tree","anchor":"call-tree"},{"id":"Key Files/Variables","anchor":"key-files-variables"}]},{"id":"customizing-systems","title":"Customizing Your Own Nerves System","group":"","headers":[{"id":"Getting Setup to Build a System","anchor":"getting-setup-to-build-a-system"},{"id":"Building the System","anchor":"building-the-system"},{"id":"Buildroot Package Configuration","anchor":"buildroot-package-configuration"},{"id":"Adding a custom Buildroot Package","anchor":"adding-a-custom-buildroot-package"},{"id":"Creating an Artifact","anchor":"creating-an-artifact"},{"id":"Custom System Maintenance","anchor":"custom-system-maintenance"}]}],"exceptions":[],"modules":[{"id":"Mix.Nerves.Shell","title":"Mix.Nerves.Shell","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"open/2","anchor":"open/2"}]}]},{"id":"Mix.Nerves.Utils","title":"Mix.Nerves.Utils","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"bytes_to_gigabytes/1","anchor":"bytes_to_gigabytes/1"},{"id":"check_host_requirements/1","anchor":"check_host_requirements/1"},{"id":"check_nerves_system_is_set!/0","anchor":"check_nerves_system_is_set!/0"},{"id":"check_nerves_toolchain_is_set!/0","anchor":"check_nerves_toolchain_is_set!/0"},{"id":"check_requirements/1","anchor":"check_requirements/1"},{"id":"debug_info/1","anchor":"debug_info/1"},{"id":"get_devs/0","anchor":"get_devs/0"},{"id":"mix_target/0","anchor":"mix_target/0"},{"id":"parse_version/1","anchor":"parse_version/1"},{"id":"preflight/0","anchor":"preflight/0"},{"id":"prompt_dev/0","anchor":"prompt_dev/0"},{"id":"sanitize_path/0","anchor":"sanitize_path/0"},{"id":"set_provisioning/1","anchor":"set_provisioning/1"},{"id":"shell/3","anchor":"shell/3"},{"id":"use_distillery?/0","anchor":"use_distillery?/0"}]}]},{"id":"Nerves","title":"Nerves","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"after_assembly/2","anchor":"after_assembly/2"},{"id":"after_cleanup/2","anchor":"after_cleanup/2"},{"id":"after_package/2","anchor":"after_package/2"},{"id":"before_assembly/2","anchor":"before_assembly/2"},{"id":"before_package/2","anchor":"before_package/2"},{"id":"elixir_version/0","anchor":"elixir_version/0"},{"id":"version/0","anchor":"version/0"}]}]},{"id":"Nerves.Artifact","title":"Nerves.Artifact","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"archive/3","anchor":"archive/3"},{"id":"base_dir/0","anchor":"base_dir/0"},{"id":"build/2","anchor":"build/2"},{"id":"build_path/1","anchor":"build_path/1"},{"id":"build_path_link/1","anchor":"build_path_link/1"},{"id":"build_runner/1","anchor":"build_runner/1"},{"id":"checksum/2","anchor":"checksum/2"},{"id":"clean/1","anchor":"clean/1"},{"id":"dir/1","anchor":"dir/1"},{"id":"download_name/2","anchor":"download_name/2"},{"id":"download_path/1","anchor":"download_path/1"},{"id":"env_var/1","anchor":"env_var/1"},{"id":"env_var?/1","anchor":"env_var?/1"},{"id":"expand_sites/1","anchor":"expand_sites/1"},{"id":"ext/1","anchor":"ext/1"},{"id":"host_tuple/1","anchor":"host_tuple/1"},{"id":"name/1","anchor":"name/1"},{"id":"parse_download_name/1","anchor":"parse_download_name/1"},{"id":"stale?/1","anchor":"stale?/1"}]}]},{"id":"Nerves.Artifact.BuildRunner","title":"Nerves.Artifact.BuildRunner","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"archive_result/0","anchor":"t:archive_result/0"},{"id":"build_result/0","anchor":"t:build_result/0"},{"id":"clean_result/0","anchor":"t:clean_result/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"archive/3","anchor":"c:archive/3"},{"id":"build/3","anchor":"c:build/3"},{"id":"clean/1","anchor":"c:clean/1"}]}]},{"id":"Nerves.Artifact.BuildRunners.Docker","title":"Nerves.Artifact.BuildRunners.Docker","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"archive/3","anchor":"archive/3"},{"id":"build/3","anchor":"build/3"},{"id":"clean/1","anchor":"clean/1"},{"id":"parse_docker_version/1","anchor":"parse_docker_version/1"},{"id":"system_shell/1","anchor":"system_shell/1"}]}]},{"id":"Nerves.Artifact.BuildRunners.Docker.Image","title":"Nerves.Artifact.BuildRunners.Docker.Image","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create/2","anchor":"create/2"},{"id":"exists?/1","anchor":"exists?/1"},{"id":"pull/1","anchor":"pull/1"}]}]},{"id":"Nerves.Artifact.BuildRunners.Docker.Utils","title":"Nerves.Artifact.BuildRunners.Docker.Utils","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"shell_info/2","anchor":"shell_info/2"}]}]},{"id":"Nerves.Artifact.BuildRunners.Docker.Volume","title":"Nerves.Artifact.BuildRunners.Docker.Volume","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"create/1","anchor":"create/1"},{"id":"create_id/1","anchor":"create_id/1"},{"id":"delete/1","anchor":"delete/1"},{"id":"exists?/1","anchor":"exists?/1"},{"id":"id/1","anchor":"id/1"},{"id":"id_file/1","anchor":"id_file/1"},{"id":"name/1","anchor":"name/1"}]}]},{"id":"Nerves.Artifact.BuildRunners.Local","title":"Nerves.Artifact.BuildRunners.Local","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"archive/3","anchor":"archive/3"},{"id":"build/3","anchor":"build/3"},{"id":"clean/1","anchor":"clean/1"},{"id":"system_shell/1","anchor":"system_shell/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"clean/1","anchor":"c:clean/1"}]}]},{"id":"Nerves.Artifact.Cache","title":"Nerves.Artifact.Cache","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"checksum_path/1","anchor":"checksum_path/1"},{"id":"delete/1","anchor":"delete/1"},{"id":"get/1","anchor":"get/1"},{"id":"path/1","anchor":"path/1"},{"id":"put/2","anchor":"put/2"},{"id":"valid?/1","anchor":"valid?/1"}]}]},{"id":"Nerves.Artifact.Resolver","title":"Nerves.Artifact.Resolver","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"do_get/3","anchor":"do_get/3"},{"id":"get/2","anchor":"get/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"get/1","anchor":"c:get/1"}]}]},{"id":"Nerves.Artifact.Resolvers.GithubAPI","title":"Nerves.Artifact.Resolvers.GithubAPI","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"get/1","anchor":"get/1"}]}]},{"id":"Nerves.Artifact.Resolvers.URI","title":"Nerves.Artifact.Resolvers.URI","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"get/1","anchor":"get/1"}]}]},{"id":"Nerves.Distillery","title":"Nerves.Distillery","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"after_assembly/1","anchor":"after_assembly/1"},{"id":"after_assembly/2","anchor":"after_assembly/2"},{"id":"after_cleanup/2","anchor":"after_cleanup/2"},{"id":"after_package/1","anchor":"after_package/1"},{"id":"after_package/2","anchor":"after_package/2"},{"id":"before_assembly/1","anchor":"before_assembly/1"},{"id":"before_assembly/2","anchor":"before_assembly/2"},{"id":"before_package/1","anchor":"before_package/1"},{"id":"before_package/2","anchor":"before_package/2"}]}]},{"id":"Nerves.Env","title":"Nerves.Env","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"bootstrap/0","anchor":"bootstrap/0"},{"id":"change_target/1","anchor":"change_target/1"},{"id":"clean/1","anchor":"clean/1"},{"id":"disable/0","anchor":"disable/0"},{"id":"download_dir/0","anchor":"download_dir/0"},{"id":"enable/0","anchor":"enable/0"},{"id":"enabled?/0","anchor":"enabled?/0"},{"id":"ensure_loaded/2","anchor":"ensure_loaded/2"},{"id":"host_arch/0","anchor":"host_arch/0"},{"id":"host_os/0","anchor":"host_os/0"},{"id":"loaded?/0","anchor":"loaded?/0"},{"id":"package/1","anchor":"package/1"},{"id":"packages/0","anchor":"packages/0"},{"id":"packages_by_type/2","anchor":"packages_by_type/2"},{"id":"start/0","anchor":"start/0"},{"id":"stop/0","anchor":"stop/0"},{"id":"system/0","anchor":"system/0"},{"id":"system_platform/0","anchor":"system_platform/0"},{"id":"toolchain/0","anchor":"toolchain/0"},{"id":"toolchain_platform/0","anchor":"toolchain_platform/0"}]}]},{"id":"Nerves.Package","title":"Nerves.Package","group":"","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"config/2","anchor":"config/2"},{"id":"config_path/1","anchor":"config_path/1"},{"id":"load_config/1","anchor":"load_config/1"},{"id":"shell/1","anchor":"shell/1"}]}]},{"id":"Nerves.Package.Platform","title":"Nerves.Package.Platform","group":"","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"id":"bootstrap/1","anchor":"c:bootstrap/1"},{"id":"build_path_link/1","anchor":"c:build_path_link/1"}]}]},{"id":"Nerves.Package.Utils.Squashfs","title":"Nerves.Package.Utils.Squashfs","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"files/1","anchor":"files/1"},{"id":"fragment/4","anchor":"fragment/4"},{"id":"init/1","anchor":"init/1"},{"id":"merge/4","anchor":"merge/4"},{"id":"path_to_paths/1","anchor":"path_to_paths/1"},{"id":"pseudofile/1","anchor":"pseudofile/1"},{"id":"pseudofile_fragment/2","anchor":"pseudofile_fragment/2"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"stop/1","anchor":"stop/1"}]}]},{"id":"Nerves.Release","title":"Nerves.Release","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"bootfile/0","anchor":"bootfile/0"},{"id":"erts/0","anchor":"erts/0"},{"id":"finalize/1","anchor":"finalize/1"},{"id":"init/1","anchor":"init/1"},{"id":"write_rootfs_priorities/3","anchor":"write_rootfs_priorities/3"}]}]},{"id":"Nerves.System.BR","title":"Nerves.System.BR","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"archive/3","anchor":"archive/3"},{"id":"bootstrap/1","anchor":"bootstrap/1"},{"id":"build/3","anchor":"build/3"},{"id":"build_path_link/1","anchor":"build_path_link/1"},{"id":"clean/1","anchor":"clean/1"}]}]},{"id":"Nerves.Utils","title":"Nerves.Utils","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"json_decode/1","anchor":"json_decode/1"},{"id":"json_encode/1","anchor":"json_encode/1"},{"id":"random_alpha_num/1","anchor":"random_alpha_num/1"},{"id":"untar/2","anchor":"untar/2"}]}]},{"id":"Nerves.Utils.File","title":"Nerves.Utils.File","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"ext_cmd/1","anchor":"ext_cmd/1"},{"id":"tar/2","anchor":"tar/2"},{"id":"untar/2","anchor":"untar/2"},{"id":"validate/1","anchor":"validate/1"}]}]},{"id":"Nerves.Utils.HTTPClient","title":"Nerves.Utils.HTTPClient","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"get/3","anchor":"get/3"},{"id":"init/1","anchor":"init/1"},{"id":"put_progress/2","anchor":"put_progress/2"},{"id":"start_link/0","anchor":"start_link/0"},{"id":"stop/1","anchor":"stop/1"}]}]},{"id":"Nerves.Utils.Proxy","title":"Nerves.Utils.Proxy","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"config/1","anchor":"config/1"}]}]},{"id":"Nerves.Utils.Shell","title":"Nerves.Utils.Shell","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"error/1","anchor":"error/1"},{"id":"info/1","anchor":"info/1"},{"id":"success/1","anchor":"success/1"},{"id":"warn/1","anchor":"warn/1"}]}]},{"id":"Nerves.Utils.Stream","title":"Nerves.Utils.Stream","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"history/1","anchor":"history/1"},{"id":"init/1","anchor":"init/1"},{"id":"reply/3","anchor":"reply/3"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"stdout/3","anchor":"stdout/3"},{"id":"stop/1","anchor":"stop/1"}]}]},{"id":"Nerves.Utils.WSL","title":"Nerves.Utils.WSL","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"admin_powershell_command/2","anchor":"admin_powershell_command/2"},{"id":"cleanup_file/2","anchor":"cleanup_file/2"},{"id":"execute_wslpath/2","anchor":"execute_wslpath/2"},{"id":"get_fwup_devices/0","anchor":"get_fwup_devices/0"},{"id":"get_temp_file_location/1","anchor":"get_temp_file_location/1"},{"id":"get_wsl_paths/2","anchor":"get_wsl_paths/2"},{"id":"has_wslpath?/0","anchor":"has_wslpath?/0"},{"id":"make_file_accessible/3","anchor":"make_file_accessible/3"},{"id":"path_accessible_in_windows?/2","anchor":"path_accessible_in_windows?/2"},{"id":"running_on_wsl?/1","anchor":"running_on_wsl?/1"},{"id":"valid_windows_path?/1","anchor":"valid_windows_path?/1"},{"id":"valid_wsl_path?/1","anchor":"valid_wsl_path?/1"}]}]}],"tasks":[{"id":"Mix.Tasks.Burn","title":"mix burn","group":""},{"id":"Mix.Tasks.Compile.NervesPackage","title":"mix compile.nerves_package","group":""},{"id":"Mix.Tasks.Firmware","title":"mix firmware","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"module_compiler_version/1","anchor":"module_compiler_version/1"},{"id":"system_otp_release/0","anchor":"system_otp_release/0"}]}]},{"id":"Mix.Tasks.Firmware.Burn","title":"mix firmware.burn","group":""},{"id":"Mix.Tasks.Firmware.Image","title":"mix firmware.image","group":""},{"id":"Mix.Tasks.Nerves.Artifact","title":"mix nerves.artifact","group":""},{"id":"Mix.Tasks.Nerves.Artifact.Get","title":"mix nerves.artifact.get","group":""},{"id":"Mix.Tasks.Nerves.Info","title":"mix nerves.info","group":""},{"id":"Mix.Tasks.Nerves.Release.Init","title":"mix nerves.release.init","group":""}]}